/// <reference types="winston" />
import * as Rx from 'rxjs';
import * as winston from 'winston';
export declare const State: {
    OK: string;
    ERROR: string;
};
export declare class QEntry<T> {
    created: Date;
    running: Date;
    retryAt: Date;
    completed: Date;
    executeCnt: number;
    task: Rx.Observable<QEntry<T>>;
    constructor(task: Rx.Observable<QEntry<T>>);
}
export interface QConfig {
    taskTimer?: number;
    reclaimTimeout?: number;
    retryWaitTime?: number;
    maxExecuteCnt?: number;
}
export declare class Queue<T> {
    q: Rx.Subject<QEntry<T>>;
    deadLetter: Rx.Subject<QEntry<T>>;
    qEntries: QEntry<T>[];
    inProcess: boolean;
    qTask: number;
    reclaimTimeout: number;
    taskTimer: number;
    retryWaitTime: number;
    maxExecuteCnt: number;
    logger: winston.LoggerInstance;
    constructor(logger: winston.LoggerInstance, argv: QConfig);
    stop(): Rx.Observable<void>;
    private action(qe);
    private processMemoryQ();
    push(action: Rx.Observable<QEntry<T>>): void;
}
export declare function start<T>(logger: winston.LoggerInstance, argv: any): Queue<T>;
export default Queue;
